package ru.dbotthepony.kstarbound.defs

import ru.dbotthepony.kstarbound.io.json.builder.JsonFactory
import ru.dbotthepony.kstarbound.util.KOptional

@JsonFactory
data class JumpProfile(
	val jumpSpeed: KOptional<Double> = KOptional.empty(),
	val jumpControlForce: KOptional<Double> = KOptional.empty(),
	val jumpInitialPercentage: KOptional<Double> = KOptional.empty(),
	val jumpHoldTime: KOptional<Double> = KOptional.empty(),
	val jumpTotalHoldTime: KOptional<Double> = KOptional.empty(),
	val multiJump: KOptional<Boolean> = KOptional.empty(),
	val reJumpDelay: KOptional<Double> = KOptional.empty(),
	val autoJump: KOptional<Boolean> = KOptional.empty(),
	val collisionCancelled: KOptional<Boolean> = KOptional.empty(),
) {
	fun merge(other: JumpProfile): JumpProfile {
		return JumpProfile(
			jumpSpeed = jumpSpeed.or(other.jumpSpeed),
			jumpControlForce = jumpControlForce.or(other.jumpControlForce),
			jumpInitialPercentage = jumpInitialPercentage.or(other.jumpInitialPercentage),
			jumpHoldTime = jumpHoldTime.or(other.jumpHoldTime),
			jumpTotalHoldTime = jumpTotalHoldTime.or(other.jumpTotalHoldTime),
			multiJump = multiJump.or(other.multiJump),
			reJumpDelay = reJumpDelay.or(other.reJumpDelay),
			autoJump = autoJump.or(other.autoJump),
			collisionCancelled = collisionCancelled.or(other.collisionCancelled),
		)
	}
}
