package ru.dbotthepony.kstarbound.defs

import com.google.common.collect.ImmutableList
import ru.dbotthepony.kstarbound.io.json.builder.JsonFactory
import ru.dbotthepony.kstarbound.io.json.builder.JsonFlat
import ru.dbotthepony.kstarbound.util.KOptional
import ru.dbotthepony.kvector.vector.Vector2d

@JsonFactory
data class MovementParameters(
	@JsonFlat
	val base: BaseMovementParameters.Impl = BaseMovementParameters.Impl(),

	val discontinuityThreshold: KOptional<Float> = KOptional.empty(),
	val collisionPoly: KOptional<ImmutableList<Vector2d>> = KOptional.empty(),
	val ignorePlatformCollision: KOptional<Boolean> = KOptional.empty(),
	val restDuration: KOptional<Int> = KOptional.empty(),
) : BaseMovementParameters by base {
	fun merge(other: MovementParameters): MovementParameters {
		return MovementParameters(
			base = base.merge(other.base),
			discontinuityThreshold = discontinuityThreshold.or(other.discontinuityThreshold),
			collisionPoly = collisionPoly.or(other.collisionPoly),
			ignorePlatformCollision = ignorePlatformCollision.or(other.ignorePlatformCollision),
			restDuration = restDuration.or(other.restDuration),
		)
	}
}
