package ru.dbotthepony.kstarbound.defs.item.impl

import com.google.common.collect.ImmutableList
import ru.dbotthepony.kstarbound.defs.IScriptable
import ru.dbotthepony.kstarbound.defs.item.api.IArmorItemDefinition
import ru.dbotthepony.kstarbound.defs.item.LeveledStatusEffect
import ru.dbotthepony.kstarbound.defs.item.api.IItemDefinition
import ru.dbotthepony.kstarbound.io.json.builder.JsonFactory
import ru.dbotthepony.kstarbound.io.json.builder.JsonFlat

@JsonFactory(logMisses = false)
data class ArmorItemDefinition(
	@JsonFlat
	val parent: IItemDefinition,
	@JsonFlat
	val script: IScriptable.Impl,

	override val maxStack: Long = 1L,

	override val colorOptions: ImmutableList<Map<String, String>> = ImmutableList.of(),
	override val maleFrames: IArmorItemDefinition.Frames,
	override val femaleFrames: IArmorItemDefinition.Frames,
	override val level: Double = 1.0,
	override val leveledStatusEffects: ImmutableList<LeveledStatusEffect> = ImmutableList.of(),
) : IArmorItemDefinition, IItemDefinition by parent, IScriptable by script

@JsonFactory(logMisses = false)
class HeadArmorItemDefinition(@JsonFlat val parent: ArmorItemDefinition) : IArmorItemDefinition by parent {
	override val itemType: String
		get() = "headarmor"
}

@JsonFactory(logMisses = false)
class ChestArmorItemDefinition(@JsonFlat val parent: ArmorItemDefinition) : IArmorItemDefinition by parent {
	override val itemType: String
		get() = "chestarmor"
}

@JsonFactory(logMisses = false)
class LegsArmorItemDefinition(@JsonFlat val parent: ArmorItemDefinition) : IArmorItemDefinition by parent {
	override val itemType: String
		get() = "legsarmor"
}

@JsonFactory(logMisses = false)
class BackArmorItemDefinition(@JsonFlat val parent: ArmorItemDefinition) : IArmorItemDefinition by parent {
	override val itemType: String
		get() = "backarmor"
}
