package ru.dbotthepony.kstarbound.defs.player

import com.google.common.collect.ImmutableList
import com.google.common.collect.ImmutableMap
import ru.dbotthepony.kstarbound.defs.AssetPath
import ru.dbotthepony.kstarbound.defs.IScriptable
import ru.dbotthepony.kstarbound.defs.RegistryReference
import ru.dbotthepony.kstarbound.defs.item.api.IItemDefinition
import ru.dbotthepony.kstarbound.io.json.builder.JsonFactory

@JsonFactory
data class DeploymentConfig(
	override val scripts: ImmutableList<AssetPath>,
	override val scriptDelta: Int,

	val starterMechSet: ImmutableMap<String, RegistryReference<IItemDefinition>>,
	val speciesStarterMechBody: ImmutableMap<String, RegistryReference<IItemDefinition>>,

	val enemyDetectRadius: Double,
	val enemyDetectTypeNames: ImmutableList<String>,

	val lowEnergyThreshold: Double,
	val lowEnergyFlashTime: Double,
	val lowEnergySound: String,
) : IScriptable
