package ru.dbotthepony.kstarbound.math

import com.google.gson.Gson
import com.google.gson.TypeAdapter
import com.google.gson.stream.JsonReader
import com.google.gson.stream.JsonWriter
import ru.dbotthepony.kstarbound.Starbound
import ru.dbotthepony.kstarbound.io.json.consumeNull
import ru.dbotthepony.kvector.vector.Vector2f

data class LineF(val start: Vector2f, val end: Vector2f) {
	class Adapter(gson: Gson) : TypeAdapter<LineF>() {
		private val vectors = gson.getAdapter(Vector2f::class.java)

		override fun write(out: JsonWriter, value: LineF?) {
			if (value == null) {
				out.nullValue()
			} else {
				out.beginArray()
				vectors.write(out, value.start)
				vectors.write(out, value.end)
				out.endArray()
			}
		}

		override fun read(`in`: JsonReader): LineF? {
			if (`in`.consumeNull()) {
				return null
			} else {
				`in`.beginArray()
				val start = vectors.read(`in`)
				val end = vectors.read(`in`)
				`in`.endArray()
				return LineF(start, end)
			}
		}
	}
}
