package ru.dbotthepony.kstarbound.util

/**
 * [Either] but with 3 values
 */
class OneOf<A, B, C> private constructor(
	val v0: KOptional<A>,
	val v1: KOptional<B>,
	val v2: KOptional<C>,
) {
	override fun equals(other: Any?): Boolean {
		return other === this || other is OneOf<*, *, *> && v0 == other.v0 && v1 == other.v1 && v2 == other.v2
	}

	override fun hashCode(): Int {
		return v0.hashCode() + v1.hashCode() * 31 + v2.hashCode() * 31 * 31
	}

	override fun toString(): String {
		return "OneOf[$v0, $v1, $v2]"
	}

	companion object {
		fun <A, B, C> first(value: A): OneOf<A, B, C> {
			return OneOf(KOptional.of(value), KOptional.empty(), KOptional.empty())
		}

		fun <A, B, C> second(value: B): OneOf<A, B, C> {
			return OneOf(KOptional.empty(), KOptional.of(value), KOptional.empty())
		}

		fun <A, B, C> third(value: C): OneOf<A, B, C> {
			return OneOf(KOptional.empty(), KOptional.empty(), KOptional.of(value))
		}
	}
}
