package ru.dbotthepony.kstarbound.world.api

import ru.dbotthepony.kstarbound.Registries
import ru.dbotthepony.kstarbound.RegistryObject
import ru.dbotthepony.kstarbound.defs.tile.LiquidDefinition
import java.io.DataInputStream

interface ILiquidState {
	var def: LiquidDefinition?
	var level: Float
	var pressure: Float
	var isInfinite: Boolean

	fun read(stream: DataInputStream) {
		def = Registries.liquid[stream.readUnsignedByte()]?.value
		level = stream.readFloat()
		pressure = stream.readFloat()
		isInfinite = stream.readBoolean()
	}

	companion object {
		fun skip(stream: DataInputStream) {
			stream.skipNBytes(1 + 4 + 4 + 1)
		}
	}
}